// Plik: fig07_21.c
// Kopiowanie ciągu tekstowego za pomocą notacji tablicy i notacji wskaźnika
#include <stdio.h>
#define SIZE 10

void copy1(char * const s1, const char * const s2); // Prototyp funkcji
void copy2(char *s1, const char *s2); // Prototyp funkcji

int main(void)
{
   char string1[SIZE]; // Utworzenie tablicy string1
   char *string2 = "Witaj"; // Utworzenie wskaźnika do ciągu tekstowego

   copy1(string1, string2);
   printf("string1 = %s\n", string1);

   char string3[SIZE]; // Utworzenie tablicy string3
   char string4[] = "Żegnaj"; // Utworzenie tablicy zawierającej ciąg tekstowy

   copy2(string3, string4);
   printf("string3 = %s\n", string3);
} 

// Kopiowanie s2 do s1 za pomocą notacji tablicy
void copy1(char * const s1, const char * const s2)
{
   // Iteracja przez ciągi tekstowe
   for (size_t i = 0; (s1[i] = s2[i]) != '\0'; ++i) {
      ; // Brak poleceń w bloku pętli
   }
} 

// Kopiowanie s2 do s1 za pomocą notacji wskaźnika
void copy2(char *s1, const char *s2)
{
   // Iteracja przez ciągi tekstowe
   for (; (*s1 = *s2) != '\0'; ++s1, ++s2) {
      ; // Brak poleceń w bloku pętli
   }
}
