// Plik: fig17_29.cpp
// Statyczne dane składowe monitorujące liczbę utworzonych egzemplarzy klasy
#include <iostream>
#include "Employee.h" // Definicja klasy Employee
using namespace std;

int main()
{  
   // Nie istnieją jeszcze żadne obiekty; nazwa klasy i operator binarny zasięgu 
   // są używanie w celu uzyskania dostępu do statycznej funkcji składowej getCount()
   cout << "Liczba egzemplarzy przed utworzeniem jakiegokolwiek obiektu wynosi "
      << Employee::getCount() << endl; // Użycie nazwy klasy

   // Następujący zasięg powoduje utworzenie i usunięcie 
   // obiektów klasy Employee przed zakończeniem funkcji main()
   {
      Employee e1( "Sara", "Baranowska" ); 
      Employee e2( "Robert", "Jaworski" );

      // Istnieją dwa obiekty; ponowne wywołanie statycznej funkcji składowej getCount()
      // z użyciem nazwy klasy i operatora ustalenia zasięgu
      cout << "Liczba egzemplarzy po utworzeniu obiektów wynosi "
         << Employee::getCount();

      cout << "\n\nEgzemplarz 1: " 
         << e1.getFirstName() << " " << e1.getLastName() 
         << "\nEgzemplarz 2: " 
         << e2.getFirstName() << " " << e2.getLastName() << "\n\n";
   } // Koniec zagnieżdżonego zasięgu w funkcji main()

   // Nie istnieją jeszcze żadne obiekty; ponownie wywoływana jest statyczna funkcja składowa getCount()
   // z użyciem nazwy klasy i operatora ustalenia zasięgu
   cout << "\nLiczba egzemplarzy po usunięciu obiektów wynosi "
      << Employee::getCount() << endl;
} // Koniec funkcji main()
